incasm "Variablen.asm"

*=$0801


          BYTE           $0B,$08,$DE,$07,$9E," 2062",$00,$00,$00 ;  BASCIZEILE 2014  SYS   2062

;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
;OO                                                                     OO
;OO                                                                     OO
;OO                          INIT                                       OO
;OO                                                                     OO
;OO                                                                     OO
;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO

        lda $0001
        sta $d020
        and #%11111110
        sta $0001                       ; BASIC AUSSCHALTEN - RAM BEI A000                                      FREIGEBEN

incasm "init bitmap.asm"

incasm "init animations.asm"            ; init flags, counter etc. / save                                               colorRAM

        jsr SR:SHOW_STANDARD_SPRITES        
        jsr SR:INIT_STANDARD_IRQS


;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
;OO                                                                     OO
;OO                                                                     OO
;OO                         TASTATURABFRAGE                             OO
;OO                                                                     OO
;OO                                                                     OO
;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO

R:TASTATURABFRAGE
 
;-----------------------------------------
;  TASTATURABFRAGE
;------------------------------------------
        lda  F_SPRECHER
        bne R:TASTATURABFRAGE           ; solange noch jemand spricht keine                                     Tastaturabfrage
        lda $CB                         ;Tastatur-Matrixkoordinate lesen
        cmp M_Tastaturspeicher          ; hat sich etwas verändert?
        beq R:TASTATURABFRAGE           ; nö? weiter warten!
        sta M_Tastaturspeicher
        cmp #$40                        ;besteht die änderung darin, dass jetzt                                 keine Taste mehr gedrückt ist?
        beq JUMP_TO_R:ANIMATION_SELECT  ; ja? Alles läuft weiter wie bisher    
        sta M_Tastaturspeicher          ; nein? D.h. es wurde gedrückt-> Speicher aktualisieren
    
JUMP_TO_R:ANIMATION_SELECT 
        jmp R:ANIMATION_SELECT 

R:ANIMATION_SELECT 
   
        lda M_Tastaturspeicher
        cmp #$1D                        ; H?
        beq JUMP_TO_R:EXPLODIER
        cmp #$27                        ; N?
        beq JUMP_TO_R:NORBERT_EDW
        cmp #$3E                        ; Q gedückt?
        beq JUMP_TO_R:_TEXT_PLUS_ANIMATION
        jmp R:TASTATURABFRAGE           ; etwas anderes gedrückt? zurück auf                                    start!

;-----------------------------------------
;  Sprungschanze: Invalid BNE/BEQ verhindern
;------------------------------------------

JUMP_TO_R:EXPLODIER
        jmp R:EXPLODIER

JUMP_TO_R:NORBERT_EDW
        jmp R:NORBERT_EDW

JUMP_TO_R:_TEXT_PLUS_ANIMATION
        jmp R:_TEXT_PLUS_ANIMATION

;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
;OO                                                                     OO
;OO                                                                     OO
;OO                          Texte und Animationen                      OO
;OO                                                                     OO
;OO                                                                     OO
;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO

R:_TEXT_PLUS_ANIMATION

;-----------------------------------------
;  Initialisierung / Textblockstart festlegen
;------------------------------------------

 lda #$9a

;        jsr SR:GET_RND          ; Zufallszahl zur Anmationsauswahl
;        and #%00001111          ;16 verschiedene Adressen
;        tax                     ; Akku nach x
;                                ;da wir mit der  Zufallszahl x-indizieren 
;        lda $9ff0,x             ;x. Wert aus Animationsblock-
;                                ;Einsprungtabelle laden
        sta MZ_Lesezeichen_Zero+1       ; als höherwertiges Lesezeichenbyte
                                        ;speichern
        lda #$00                            
        sta MZ_Lesezeichen_Zero         ; Lo-Byte auf 0

;-----------------------------------------
;  Initialisierung aktuelle Sprechblase
;------------------------------------------

R:NAECHSTE_SPRECHBLASE
        
        jsr SR:CLEARTEXT 

        ;........... Index Y auf 0 -> anfang der Sprechblase
        
        ldy #$00
        clc

        ;........... Befehlsbyte lesen
        ;........... 9800 + x (erster durchlauf: +0)

        lda (MZ_Lesezeichen_Zero),y
        sta F_Sprecher                 ;in Sprecher-Flag speichern

;-----------------------------------------
; SPRECHER-ABFRAGE
;------------------------------------------

; ABFRAGE_OB_NORBERT_SPRICHT
      
        ;lda F_Sprecher                 ; ist eh noch im Akku
        cmp #$01                        ; 1 heißt: Norbert spricht
        bne R:ABFRAGE_OB_KLOSS_SPRICHT  ; nein? als nächstes Kloß abfragen!
                
; NORBERT SPRICHT

        lda SPRITE1OFFSET_BLICK_ZU_NORBERT ; (Kloßens Blickrichtung ändern)
        sta SPRITE1DATA
        lda #$05
        sta M_Standard_Farbe_Texthintergrund ; Text-BG=grün
        jmp R:ABFRAGE_SPRECHDAUER 

; ABFRAGE_OB_Kloss_SPRICHT
R:ABFRAGE_OB_KLOSS_SPRICHT

        lda F_Sprecher
        cmp #$02                        ; 
        bne R:ABFRAGE_OB_SPINNE_SPRICHT  ; nein? als nächstes Spinne abfragen!
                                          
; KLOSS SPRICHT

        lda SPRITE1OFFSET_BLICK_STANDARD ; KLoß Blick nach unten 
        sta SPRITE1DATA
        lda #$0e
        sta M_Standard_Farbe_Texthintergrund ; Text-BG=blau
        jmp R:ABFRAGE_SPRECHDAUER              

; ABFRAGE_OB_SPINNE_SPRICHT
R:ABFRAGE_OB_SPINNE_SPRICHT
        
        lda F_Sprecher        
        cmp #$03 
        bne R:ABFRAGE_OB_NIEMAND_SPRICHT  ; auch nicht? weiter abfragen!

; SPINNE SPRICHT
       
        lda SPRITE1OFFSET_BLICK_ZU_SPINNE ; KLoß Blick zu Spinne
        sta SPRITE1DATA
        lda #$02
        sta M_Standard_Farbe_Texthintergrund ; Text-BG=rot
        jmp R:ABFRAGE_SPRECHDAUER 

R:ABFRAGE_OB_NIEMAND_SPRICHT
        
        lda F_Sprecher        
        cmp #$00 
        bne R:ABFRAGE_SPRECHDAUER   ; auch nicht? weiter zur näxten abt.!

; NIEMAND SPRICHT
       
        lda SPRITE1OFFSET_BLICK_STANDARD ; KLoß Blick nach unten 
        sta SPRITE1DATA
        lda #$0f
        sta M_Standard_Farbe_Texthintergrund
        jmp R:ABFRAGE_SPRECHDAUER 

;-----------------------------------------
; ABFRAGE DER SPRECHDAUER
;------------------------------------------           
R:ABFRAGE_SPRECHDAUER                   
        
        ldy #$01

        ;........... Befehlsbyte 2 lesen
        ;........... 9800 + y (+1)

        lda (MZ_Lesezeichen_Zero),y
        sta C_countdown_sprachdauer 
        
        lda F_Sprecher        
        ;........... Eine 0 heißt:NIEMAND spricht -> weiter zur Warteschleife
        cmp            #$00 
        bne R:INIT_OUTPUT_TEXT  ; nicht 0? Text ausgeben
        ;-----------doch 0? Kein Sprecher? Kein Text?
        jmp R:NAECHSTE_ANIMATION_STARTEN               
      
;-----------------------------------------
; TEXTAUSGABE INITIALISIEREN
;------------------------------------------  

R:INIT_OUTPUT_TEXT

        clc
        ;........... X wird der Zähler für die Schreibschleife  
        ldy #$00
;-----------------------------------------
; TEXTAUSGABE LOOP
;------------------------------------------  

R:OUTPUT_TEXT
       
        lda   (MZ_Lesezeichen_Zero),y  


; ABFRAGE DER END-BEFEHLE
;---------------------------------
        
        cmp #$fe
        beq R:NAECHSTE_ANIMATION_STARTEN
        cmp #$ff
        beq R:NEUE_TASTATUR_ABFRAGE
        ;.......Nichts davon? Zeichen ausgeben!
        sta $43fe,y
        iny 
        jmp R:OUTPUT_TEXT
        
R:NAECHSTE_ANIMATION_STARTEN
         ;.......warten bis Dauer abgelaufen (in interrupt S2) 
        lda C_countdown_sprachdauer
        bne R:NAECHSTE_ANIMATION_STARTEN
        
        lda SPRITE6OFFSET           ; Münder auf Anfangswert
        sta SPRITE6DATA 
        lda SPRITE7OFFSET
        sta SPRITE7DATA
        lda SPRITE4OFFSET
        sta SPRITE4DATA
        lda SPRITE5OFFSET
        sta SPRITE5DATA
        
        ;.......y zu Lesezeichen Zero Lobyte dazuadieren
        
        tya    ; y in den Akku
        adc MZ_Lesezeichen_Zero ; aktuelles Lobyte Lesezeichen dazuaddieren
        sta MZ_Lesezeichen_Zero ; und wieder dort speichern
        bcs R:NEXT_256er_PAGE   ; wenn Lobyte-Überlauf
        jmp R:NAECHSTE_SPRECHBLASE

R:NEXT_256er_PAGE
        inc MZ_Lesezeichen_Zero+1 ; HiByte erhöhen, umblättern
        clc
        jmp R:NAECHSTE_SPRECHBLASE

R:NEUE_TASTATUR_ABFRAGE
        jmp R:TASTATURABFRAGE






;-----------------------------------------
; Andere Programmteile inkludieren
;------------------------------------------

incasm "init irq.asm"

incasm "NorbertWelt.asm"

incasm  "Explosion.asm"

incasm "show sprites.asm"

incasm "interrupt S1 - Textfenster.asm"

incasm "interrupt S2 - Screen Split.asm"

incasm "interrupt S3 - Animationen.asm"

incasm "interrupt N1 - Splitscreen.asm" 

incasm "interrupt N2 - Top Sprites.asm"

incasm "interrupt N3 - bottom Sprites.asm"

incasm "subroutines.asm"


;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
;OO                                                                     OO
;OO                                                                     OO
;OO                      DATEN                                          OO
;OO                                                                     OO
;OO                                                                     OO
;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
#region

;-----------------------------------------
; Charset
;------------------------------------------


*=$4800           ;charset DATEN ab 4800

incbin    "c64_lower.64c",2


;-----------------------------------------
; SPRITES
;------------------------------------------


*=$5000           ;SPRITE DATEN ab 5000

incbin    "Sprites05.bin"

;-----------------------------------------
; BILD
;------------------------------------------

*=$6000                      
incbin    "spin07.koa",2        ;Bild einbinden


;-----------------------------------------
; TEXT
;------------------------------------------

*=$9800

   

        byte            $ff         ; Ende des Animationsblocks 
;..........................................
      
*=$9a00
        byte            03, 70      ; Figur 3 (Spinne)
        text            'Norbert, machste mir ne Brause?'
        byte            $fe
        
        byte            00, 20      ; Pause
        byte            $fe


        byte            01, $cc      ; Figur 1 (Norbert)
        text            'Brause ham wer nich. Schnaps kannste    '
        text            'haben.'
        byte            $fe

        
        byte            03, $b0      ; Figur 3 (Spinne) 
        text            'Och, nee, lass mal. n andermal gerne.   '
        text            'Und Kloss, wie gehts?            '
        byte            $fe

        byte            02, $cc      ; Figur 1 (Norbert)
        text            'Scheisse gehts. Manchmal denk ich, wir  '
        text            'leben in der Matrix ... '
        byte            $fe

        byte            00, 30      ; Pause
        byte            $fe

        byte            02, $a0      ; Figur 2 (Kloß) 
        text            '... und die Matrix ist ein C64!          '
        byte            $ff

      
       

;..........................................
       

*=$9c00

         byte            00, 10      ; Pause
        byte            $fe

        byte            03, $40      ; Figur 3 (Spinne) 
        text            'Och ... '
        byte            $fe

        byte            03, $80      ; Figur 3 (Spinne) 
        text            'Solangs kein Windows-PC ist! Stell dir   '
        text            'vor: dauernd nervige Updates und ...'
        byte            $fe

        
  
        byte            01, $c0    ; Figur 1 (Norbert) 
        text            '... und wenn jemand Brause bestellt,    '
        text            'gibts einen "schweren Ausnahmefehler"!'
        byte            $fe

        byte            00, 10      ; Pause
        byte            $fe

        byte            03, $a0      ; Figur 3 (Spinne)
        text            'Hihi. Du bist lustig. Und wenn ich in   ' 
        text            'der C64-Welt Brause bestelle?'
        byte            $fe

        byte            00, 10      ; Pause
        byte            $fe

        byte            01, $c0    ; Figur 1 (Norbert)
        text            'An deiner Stelle wuerde ichs nicht aus- '
        text            'probieren, Sportsfreund!'
    
        byte            $ff
;..........................................
       
*=$9e00

        byte            00, 02, $ff          ; Niemand spricht, Dauer 2, Ende

;Einsprungtabelle für Animationsblöcke     
*=$9ff0
        byte $98, $9a, $9c, $9e
        byte $98, $9a, $9c, $9e
        byte $98, $9a, $9c, $9e
        byte $98, $9a, $9c, $9e




;        byte $98, $99, $9a, $98
;        byte $98, $99, $9a, $98
;        byte $98, $99, $9a, $98
;        byte $98, $99, $9a, $98

;-----------------------------------------
; Softsprites
;------------------------------------------

*=$a000                       
incbin    "shapestest3.koa",2
