Operator  Calc                     ;wird erst ab CBM prg Studio 2.8.0 benötigt!
;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
;OO                                                                     OO
;OO                                                                     OO
;OO                      VORAB: VARIABLEN UND ADRESSEN                  OO
;OO                                                                     OO
;OO                                                                     OO
;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO





;**********************    VIC DEFINITIONS ************************************
#region
;*** VIC-II Speicher-Konstanten
VICBANKNO = 1                      ;Nr. (0 - 3) der 16KB Bank                              | Standard: 0
VICSCREENBLOCKNO = 1                      ;Nr. (0 -15) des 1KB-Blocks für den Textbildschirm      | Standard: 1
VICCHARSETBLOCKNO = 2                      ;Nr. (0 - 7) des 2KB-Blocks für den Zeichensatz         | Standard: 2
VICBITMAPBBLOCKNO = 1                      ;Nr. (0 - 1) des 8KB-Blocks für die BITMAP-Grafik       | Standard: 0
VICBASEADR = VICBANKNO*16384          ;Startadresse der gewählten VIC-Bank                    | Standard: $0000
VICCHARSETADR = VICCHARSETBLOCKNO*2048          ;Adresse des Zeichensatzes                              | Standard: $1000 ($D000)
VICCHARSETADR = VICCHARSETADR+VICBASEADR
VICSCREENRAM = VICSCREENBLOCKNO*1024          ;Adresse des Bildschirmspeichers
VICSCREENRAM = VICSCREENRAM +VICBASEADR
VICBITMAPADR = VICBITMAPBBLOCKNO * 8192          ;Adresse der BITMAP
VICBITMAPADR = VICBASEADR + VICBITMAPADR
VICCOLORRAM = $D800

shape01_in = $a000

;shape01_out = $6ba0+$38
shape01_out = $6b00

shape1_c1_in = $bf40     ;(a000+1f40 + screenoffset)
shape1_c2_in = $C328; ;(a000+2328 + screenoffset)
shape1_c1_out = VICSCREENRAM+$0160
shape1_c2_out = VICCOLORRAM+$0160






;*******************************************************************************
;*** Die VIC II Register  -  ANFANG                                          ***
;*******************************************************************************
VICBASE   = $D000                  ;(RG) = Register-Nr.

SCREENRAM = $4400                  ;Beginn des Bildschirmspeichers

#endregion
*=$0801
          BYTE           $0B,$08,$DE,$07,$9E," 2062",$00,$00,$00 ;  BASCIZEILE 2014  SYS   2062
;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
;OO                                                                     OO
;OO                                                                     OO
;OO                          INIT                                       OO
;OO                                                                     OO
;OO                                                                     OO
;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
#region
main

 lda $0001
 and #%11111110
 sta $0001                      ; BASIC aus

;************************************
;*       VIC BANK UMSCHALTEN      ***
;************************************
#region
          lda            #%00000011;Datenrichtung für BIT 0 & 1 des Port-A
          sta            $DD02     ;zum Schreiben freigeben
          lda            #%00000010;Bank-1
          sta            $DD00     ;auswählen
#endregion


;************************************
;*       Bitmap zeigen            ***
;************************************
#region
;***Bitmap-Modus aktivieren
          lda            $D011     ;VIC-II Register 17 in den Akku
          ora            #%00100000;Bitmap-Modus
          sta            $D011     ;aktivieren
          lda            $D016     ;VIC-II Register 22 in den Akku
          ora            #%00010000;Multi-Color über BIT-4
          sta            $D016     ;aktivieren
                                   ;*** Start des Bitmapspeichers festlegen
          lda            $D018     ;VIC-II Register 24 in den Akku holen
          and            #%11110111;Mit BIT-3
          ora            #VICBITMAPBBLOCKNO*8;den Beginn des
          sta            $D018     ;Bitmapspeichers festlegen
          jsr            showKoala ;Koala-Bild anzeigen
          jmp            *         ;Endlosschleife


;*** Unkomprimiertes Koalabild anzeigen
;*** Offset (hex): Inhalt
;*** 0000 - 1F3F : Bitmap 8000 Bytes
;*** 1F40 - 2327 : Bildschirmspeicher 1000 Bytes
;*** 2328 - 270F : Farb-RAM 1000 Bytes
;*** 2710        : Hintergrundfarbe 1 Byte
showKoala
          ldx            #$00
@loop
          lda            VICBITMAPADR+$1F40,X;Farbe für Bildschirm-Speicher lesen
          sta            VICSCREENRAM,X;und schreiben
          lda            VICBITMAPADR+$2328,X;Farbe für COLOR-RAM lesen
          sta            VICCOLORRAM,X;und schreiben
          lda            VICBITMAPADR+$2040,X;für die nächsten drei Pages wiederholen
          sta            VICSCREENRAM+256,X
          lda            VICBITMAPADR+$2428,X
          sta            VICCOLORRAM+256,X
          lda            VICBITMAPADR+$2140,X
          sta            VICSCREENRAM+512,X
          lda            VICBITMAPADR+$2528,X
          sta            VICCOLORRAM+512,X
          lda            VICBITMAPADR+$2240,X
          sta            VICSCREENRAM+768,X
          lda            VICBITMAPADR+$2628,X
          sta            VICCOLORRAM+768,X
          dex                      ;Schleifenzähler verringern
          bne            @loop     ;solange ungleich 0 -> @loop
        




 


  lda            #$00
          sta            $D021     ;Hintergrundfarbe setzen
  sta            $D020    ;Rahmenfarbe setzen
#endregion

;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
;OO                                                                     OO
;OO                                                                     OO
;OO                          HAUPTPROGRAMM                              OO
;OO                                                                     OO
;OO                                                                     OO
;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO

PLOTSHAPE_01

@wait 

 lda $CB
 cmp #$40
 beq @wait


 lda            #$01
          sta            $D021     ;Hintergrundfarbe setzen#


          sta            $D020    ;Hintergrundfarbe setzen

#region


 


 ldx #00

@SHAPE_loop
 lda shape01_in,x 
 sta shape01_out,x
 
 lda shape01_in+ $140,x 
 sta shape01_out + $140,x
 
 lda shape01_in + $280,x 
 sta shape01_out + $280,x

 
 lda shape01_in + $3c0,x 
 sta shape01_out + $3c0,x 

 lda shape01_in + $500,x 
 sta shape01_out + $500,x 

 lda shape01_in + $640,x 
 sta shape01_out + $640,x 

 lda shape01_in + $780,x 
 sta shape01_out + $780,x 

 inx
 cpx #$40
 bne @SHAPE_loop

 ldx #0

@COLOR_loop

 lda            shape1_c1_in,X
 sta            shape1_c1_out,X
 lda            shape1_c2_in,x
 sta            shape1_c2_out,X

 lda            shape1_c1_in +40 ,X
 sta            shape1_c1_out+40,X
 lda            shape1_c2_in+40,x
 sta            shape1_c2_out+40,X

 lda            shape1_c1_in+80,X
 sta            shape1_c1_out+80,X
 lda            shape1_c2_in+80,X
 sta            shape1_c2_out+80,X

 lda            shape1_c1_in+120,X
 sta            shape1_c1_out+120,X
 lda            shape1_c2_in+120,X
 sta            shape1_c2_out+120,x

 lda            shape1_c1_in+160,X
 sta            shape1_c1_out+160,X
 lda            shape1_c2_in+160,X
 sta            shape1_c2_out+160,X

 lda            shape1_c1_in+200,X
 sta            shape1_c1_out+200,X
 lda            shape1_c2_in+200,X
 sta            shape1_c2_out+200,X

 lda            shape1_c1_in+240,X
 sta            shape1_c1_out+240,X
 lda            shape1_c2_in+240,X
 sta            shape1_c2_out+240,X

 inx 
 cpx #$08
 bne @COLOR_loop

#endregion




 jsr SUBVERZ

 lda            #$00
          sta            $D021     ;Hintergrundfarbe setzen
  sta            $D020    ;Hintergrundfarbe setzen

PLOT_SHAPE_02

#region



 ldx #00

@SHAPE_loop2
 lda shape01_in+$40,x 
 sta shape01_out,x
 
 lda shape01_in+ $180,x 
 sta shape01_out + $140,x
 
 lda shape01_in + $2c0,x 
 sta shape01_out + $280,x

 
 lda shape01_in + $400,x 
 sta shape01_out + $3c0,x 

 lda shape01_in + $540,x 
 sta shape01_out + $500,x 

 lda shape01_in + $680,x 
 sta shape01_out + $640,x 

 lda shape01_in + $7c0,x 
 sta shape01_out + $780,x 

 inx
 cpx #$40
 bne @SHAPE_loop2



 ldx #00

@COLOR_loop2


 lda            shape1_c1_in+8,X
 sta            shape1_c1_out,X
 lda            shape1_c2_in+8,x
 sta            shape1_c2_out,X

 lda            shape1_c1_in +48 ,X
 sta            shape1_c1_out+40,X
 lda            shape1_c2_in+48,x
 sta            shape1_c2_out+40,X

 lda            shape1_c1_in+88,X
 sta            shape1_c1_out+80,X
 lda            shape1_c2_in+88,X
 sta            shape1_c2_out+80,X

 lda            shape1_c1_in+128,X
 sta            shape1_c1_out+120,X
 lda            shape1_c2_in+128,X
 sta            shape1_c2_out+120,x

 lda            shape1_c1_in+168,X
 sta            shape1_c1_out+160,X
 lda            shape1_c2_in+168,X
 sta            shape1_c2_out+160,X

 lda            shape1_c1_in+208,X
 sta            shape1_c1_out+200,X
 lda            shape1_c2_in+208,X
 sta            shape1_c2_out+200,X

 lda            shape1_c1_in+248,X
 sta            shape1_c1_out+240,X
 lda            shape1_c2_in+248,X
 sta            shape1_c2_out+240,X

 inx 
 cpx #$08
 bne @COLOR_loop2


#endregion


 jsr SUBVERZ




PLOT_SHAPE_03

#region


PLOT_SHAPE_3
 ldx #00

@SHAPE_loop3
 lda shape01_in+$80,x 
 sta shape01_out,x
 
 lda shape01_in+ $1c0,x 
 sta shape01_out + $140,x
 
 lda shape01_in + $300,x 
 sta shape01_out + $280,x

 
 lda shape01_in + $440,x 
 sta shape01_out + $3c0,x 

 lda shape01_in + $580,x 
 sta shape01_out + $500,x 

 lda shape01_in + $6c0,x 
 sta shape01_out + $640,x 

 lda shape01_in + $800,x 
 sta shape01_out + $780,x 

 inx
 cpx #$40
 bne @SHAPE_loop3



 ldx #0

@COLOR_loop3

 lda            shape1_c1_in+16,X
 sta            shape1_c1_out,X
 lda            shape1_c2_in+16,x
 sta            shape1_c2_out,X

 lda            shape1_c1_in +56 ,X
 sta            shape1_c1_out+40,X
 lda            shape1_c2_in+56,x
 sta            shape1_c2_out+40,X

 lda            shape1_c1_in+96,X
 sta            shape1_c1_out+80,X
 lda            shape1_c2_in+96,X
 sta            shape1_c2_out+80,X

 lda            shape1_c1_in+136,X
 sta            shape1_c1_out+120,X
 lda            shape1_c2_in+136,X
 sta            shape1_c2_out+120,x

 lda            shape1_c1_in+176,X
 sta            shape1_c1_out+160,X
 lda            shape1_c2_in+176,X
 sta            shape1_c2_out+160,X

 lda            shape1_c1_in+216,X
 sta            shape1_c1_out+200,X
 lda            shape1_c2_in+216,X
 sta            shape1_c2_out+200,X

 lda            shape1_c1_in+256,X
 sta            shape1_c1_out+240,X
 lda            shape1_c2_in+256,X
 sta            shape1_c2_out+240,X

 


 inx 
 cpx #$08
 bne @COLOR_loop3








#endregion



 jsr SUBVERZ


PLOT_SHAPE_04

#region


PLOT_SHAPE_4
 ldx #00

@SHAPE_loop4
 lda shape01_in+$c0,x 
 sta shape01_out,x
 
 lda shape01_in+ $200,x 
 sta shape01_out + $140,x
 
 lda shape01_in + $340,x 
 sta shape01_out + $280,x

 
 lda shape01_in + $480,x 
 sta shape01_out + $3c0,x 

 lda shape01_in + $5c0,x 
 sta shape01_out + $500,x 

 lda shape01_in + $700,x 
 sta shape01_out + $640,x 

 lda shape01_in + $840,x 
 sta shape01_out + $780,x 

 inx
 cpx #$40
 bne @SHAPE_loop4



 ldx #0

@COLOR_loop4

 lda            shape1_c1_in+$18,X
 sta            shape1_c1_out,X
 lda            shape1_c2_in+$18,x
 sta            shape1_c2_out,X

 lda            shape1_c1_in +$40 ,X
 sta            shape1_c1_out+40,X
 lda            shape1_c2_in+$40,x
 sta            shape1_c2_out+40,X

 lda            shape1_c1_in+$68,X
 sta            shape1_c1_out+80,X
 lda            shape1_c2_in+$68,X
 sta            shape1_c2_out+80,X

 lda            shape1_c1_in+$90,X
 sta            shape1_c1_out+120,X
 lda            shape1_c2_in+$90,X
 sta            shape1_c2_out+120,x

 lda            shape1_c1_in+$b8,X
 sta            shape1_c1_out+160,X
 lda            shape1_c2_in+$b8,X
 sta            shape1_c2_out+160,X

 lda            shape1_c1_in+$e0,X
 sta            shape1_c1_out+200,X
 lda            shape1_c2_in+$e0,X
 sta            shape1_c2_out+200,X

 lda            shape1_c1_in+$108,X
 sta            shape1_c1_out+240,X
 lda            shape1_c2_in+$108,X
 sta            shape1_c2_out+240,X

 


 inx 
 cpx #$08
 bne @COLOR_loop4




#endregion


LOT_SHAPE_05

#region


PLOT_SHAPE_5
 ldx #00

@SHAPE_loop5
 lda shape01_in+$100,x 
 sta shape01_out,x
 
 lda shape01_in+ $240,x 
 sta shape01_out + $140,x
 
 lda shape01_in + $380,x 
 sta shape01_out + $280,x

 
 lda shape01_in + $4c0,x 
 sta shape01_out + $3c0,x 

 lda shape01_in + $600,x 
 sta shape01_out + $500,x 

 lda shape01_in + $740,x 
 sta shape01_out + $640,x 

 lda shape01_in + $880,x 
 sta shape01_out + $780,x 

 inx
 cpx #$40
 bne @SHAPE_loop5



 ldx #0

@COLOR_loop5

 lda            shape1_c1_in+$20,X
 sta            shape1_c1_out,X
 lda            shape1_c2_in+$20,x
 sta            shape1_c2_out,X

 lda            shape1_c1_in +$48 ,X
 sta            shape1_c1_out+40,X
 lda            shape1_c2_in+$48,x
 sta            shape1_c2_out+40,X

 lda            shape1_c1_in+$70,X
 sta            shape1_c1_out+80,X
 lda            shape1_c2_in+$70,X
 sta            shape1_c2_out+80,X

 lda            shape1_c1_in+$98,X
 sta            shape1_c1_out+120,X
 lda            shape1_c2_in+$98,X
 sta            shape1_c2_out+120,x

 lda            shape1_c1_in+$c0,X
 sta            shape1_c1_out+160,X
 lda            shape1_c2_in+$c0,X
 sta            shape1_c2_out+160,X

 lda            shape1_c1_in+$e8,X
 sta            shape1_c1_out+200,X
 lda            shape1_c2_in+$e8,X
 sta            shape1_c2_out+200,X

 lda            shape1_c1_in+$110,X
 sta            shape1_c1_out+240,X
 lda            shape1_c2_in+$110,X
 sta            shape1_c2_out+240,X

 


 inx 
 cpx #$08
 bne @COLOR_loop5



 rts




#endregion


 rts

SUBVERZ
 ldy #$00
Verz256
 ldx #00
Verz
 
 inx
 cpx #$ff
 bne Verz
 iny
 cpy #$28
 bne Verz256
 rts





















;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
;OO                                                                     OO
;OO                                                                     OO
;OO                      DATEN                                          OO
;OO                                                                     OO
;OO                                                                     OO
;OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
#region
;*************************   BILD LADEN
*=$6000                       ;das Prg Studio mag hier keine Konstanten!!!
incbin    "spin04.koa",2        ;Bild einbinden
;*************************   BILD 2LADEN
*=$a000                       ;das Prg Studio mag hier keine Konstanten!!!
incbin    "shapestest2.koa",2





#endregion
